clear;
clc;

%%%------------------------------------------------------------------------
%%
dynare TOY_Dynamics.mod

%%%------------------------------------------------------------------------
%% Firm-Level Turbulence Shock from Deterministic SS
hh = 1;
figure(hh)
ii = 0;
ii = ii+1;
subplot(2,3,ii);
plot(logY_erho*100, 'LineWidth', 1.5);
hold on;
plot(zeros(size(logY_erho)),'k--','Linewidth',1);
title('Output', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(logVbar_erho*100, 'LineWidth', 1.5);
hold on;
plot(zeros(size(logY_erho)),'k--','Linewidth',1);
title('Firm Value', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(logZ_erho*100, 'LineWidth', 1.5);
hold on;
plot(zeros(size(logY_erho)),'k--','Linewidth',1);
title('Endo. TFP', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(logVbar_7030_erho*100, 'LineWidth', 1.5);
hold on;
plot(zeros(size(logY_erho)),'k--','Linewidth',1);
title('IQR V: 70%-30%', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(logN_7030_erho*100, 'LineWidth', 1.5);
hold on;
plot(zeros(size(logY_erho)),'k--','Linewidth',1);
title('IQR N: 70%-30%', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(-logrho_erho*100, 'LineWidth', 1.5);
hold on;
plot(zeros(size(logY_erho)),'k--','Linewidth',1);
title('Uncertainty (1-\rho)', 'fontweight', 'bold');
% sgtitle('IRF to Firm-Level Turbulence Shock (% deviation)')

saveas(figure(hh),'fig_toy_irf_rho_dss.png')

%%%------------------------------------------------------------------------
%% Firm-Level Turbulence Shock from Stochastic SS
hh =hh+1;
figure(hh)
ii = 0;
ii = ii+1;
subplot(2,3,ii);
plot(IRF_rho_shock_pc_mat(:,Y_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('Output', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_rho_shock_pc_mat(:,W_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('Wage', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_rho_shock_pc_mat(:,Z_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('Endo. TFP', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_rho_shock_pc_mat(:,Y_7030_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('IQR Y: 70%-30%', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_rho_shock_pc_mat(:,N_7030_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('IQR N: 90%- 10%', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(-logrho_erho*100, 'LineWidth', 1.5);
hold on;
plot(zeros(size(logY_erho)),'k--','Linewidth',1);
title('Uncertainty (1-\rho)', 'fontweight', 'bold');

% sgtitle('IRF to Firm-Level Turbulence Shock (% deviation)')
saveas(figure(hh),'fig_toy_irf_rho_sss.png')


%%%------------------------------------------------------------------------
%%% Firm-Level Distortion Uncertainty Shock
hh =hh+1;
figure(hh)
ii = 0;
ii = ii+1;
subplot(2,3,ii);
plot(IRF_SigmaE_shock_pc_mat(:,Y_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('Output', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_SigmaE_shock_pc_mat(:,W_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('Wage', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_SigmaE_shock_pc_mat(:,Z_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('Endo. TFP', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_SigmaE_shock_pc_mat(:,Y_7030_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('IQR Y: 70%-30%', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_SigmaE_shock_pc_mat(:,N_7030_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('IQR N: 90%- 10%', 'fontweight', 'bold');

ii = ii+1;
subplot(2,3,ii);
plot(IRF_SigmaE_shock_pc_mat(:,psigma_pos)*100, 'LineWidth', 1.5);
hold on;
plot(zeros(IRF_periods),'k--','Linewidth',1);
title('S.D. of \tau', 'fontweight', 'bold');

% sgtitle('IRF to Firm-Level Second-Moment Shock (% deviation)')
saveas(figure(hh),'fig_toy_irf_sigma.png')